%
%%%%%%%%%%%%%%%%%%%%%%

function [ NMIris NMIConsensus MODris MODmeanLivelli] =MultiGA(numlivelli,fileinput,fileclassi,numclassi,mutationRate,CrossoverFraction,maxGen,PopSize,maxnum,vettorizzato)

fileout=sprintf('%s.ris',fileclassi);
fileout1=sprintf('%s.sol',fileclassi);

[fid, message] = fopen(fileout,'wt');
[fid1, message] = fopen(fileout1,'wt');



%M1 = edges2adj(fileinput,dim); %generate the adjacency matrix M1 with dim rows and columns
                                   %from fileinput that contains the edges
                                   
[M1]=MLedgesToadj(fileinput,numlivelli); %M1  una tensore, ogni elemento di M1  una matrice di adiacenza relativa ad un livello della multilayer
%[M1]=fileinput;


M=M1(:,:,1); 
for i=1:numlivelli-1 
M1(:,:,i+1);    
M=(M|M1(:,:,i+1)); 
end 
numberOfVariables = size(M,1); 

M=sparse(M);   


for k=1:numberOfVariables            %per ogni nodo si calcola l'elenco dei vicini (sulla multiplex corrispondente)
  Neighbor{k} = find(M(k,:));
end

for k=1:numberOfVariables            %per ogni nodo si calcola il  vicino migliore
    if (Neighbor{k}==0) 
        bestNN(k)=0;
    else
      bestNN(k) = bestNeighbor(k,Neighbor);
    end
end

%maxnum=1; %it is the number of datasets on which the algorithm is executed
timetot=0;

NMIris = zeros(maxnum,2); %NMI contiene per ogni iterazione, il valore massimo
%di NMI ottenuto ed il corrispondente valore di modularit? nelle prime due
%posizioni,  
 
NMIConsensus=zeros(maxnum,2); %contiene  il valore di NMI e corr. modularit? del modello scelto con il consensus

MODris = zeros(maxnum,2); %MOD contiene per ogni iterazione, il valore massimo
%di MOD ottenuto ed il corrispondente valore di NMI nelle prime due posizioni, 
%mentre nella terza c'? il valore medio massimo di modulatit? su tutti i livelli ed il corrispondente NMI 

MODmeanLivelli = zeros(maxnum,2);%contiene il valore medio massimo di modulatit? su tutti i livelli ed il corrispondente NMI

for numtest = 1:maxnum

type create_population.m;

%%
% The custom crossover function takes a cell array, the population, and
% returns a cell array, the children that result from the crossover.
type crossover_cluster.m;

%%
% The custom mutation function takes an individual, which is a clustering, and returns a 
%mutated individual in which the node connectet to a gene at position i is substituted with 
%one of its neighbors.

type mutate_cluster.m;

%%
% We also need a fitness function for the problem. The
% fitness of an individual is the sum of the score of each cluster
% 
type MOcluster_fitness.m;



FitnessFcn = @(x)MOcluster_fitness(x,M1);
 
 
options = gaoptimset('PopulationType', 'custom','PopInitRange', ...
    [1;numberOfVariables]);

Elitecount=(options.PopulationSize*10)/100;

options = gaoptimset(options,'CreationFcn',{@create_population, bestNN,Neighbor}, ...
    'CrossoverFcn',{@crossover_cluster},...
    'MutationFcn',{@mutate_cluster, mutationRate,Neighbor}, ...
    'PlotFcn', {@plotfun,@gaplotscores,@gaplotpareto,@gaplotscorediversity}, ...
    'SelectionFcn',@selectiontournament, ...
    'Generations',maxGen,'PopulationSize',PopSize, ...
    'StallTimeLimit',2000, ...
    'StallGenLimit',20,'Vectorized',vettorizzato);
hold on
%lb=zeros(numberOfVariables,1);
lb=[];
%ub=zeros(numberOfVariables,1);
ub=[];
tic
[x,fval,reason,output,population,scores] = gamultiobj(FitnessFcn,numberOfVariables,[],[],[],[],lb,ub,options);
%disp('dopo la chiamata di gamultiobj')
%x
%fval


time=toc;
timetot=timetot+time;

%delete duplicate solutions

duplicates=ones(size(x,1),1);

for i=1:size(x,1)
    
    for j=i+1:size(x,1)
        if (fval(i,1) == fval(j,1) & fval(i,2) == fval(j,2))
            duplicates(j,1)=0;
        end
    end
end
%duplicates
risultato=zeros(1,numlivelli+4);
j=1;

ns=0;%number of distinct solutions from the pareto front
for i=1:size(x,1)
    
    if (duplicates(i,1) ==1)
       %disp('solution number: ') 
       %i
       CC=decodenew(x(i,:));
       ns=ns+1;
       H{ns}=membershipMatrix(CC,numberOfVariables);
%        


if numclassi>0
 classi=load(fileclassi);
 CM=confusionMatrix(CC,classi,numclassi); %generate confusion matrix 
 fprintf(fid,'confusion matrix: %d\n',i);
 for i1 = 1:size(CM,1)
    for j1= 1:size(CM,2)
       
            fprintf(fid,'%d ',CM(i1,j1));
    end
    fprintf(fid,'\n');
 end
 fprintf(fid,'\n');
end
%print the current solution
fprintf(fid1,'communities of solution %d\n',i);

for i1=1:size(CC,2) %
    listnodes=CC{i1};
    for j1 = 1: size(listnodes,2)
        fprintf(fid1,'%d ',listnodes(j1));
    end
    fprintf(fid1,'\n');
end

Modularity = computeMod(CC,M);
%compute the  normalized mutual information 
if numclassi > 0
       NMI = computeNMI(CM,numberOfVariables);
else NMI =0;
end
       for jf=1:numlivelli
         risultato(j,jf)=fval(i,jf);
       end
       
       risultato(j,numlivelli+1)=Modularity;
       risultato(j,numlivelli+2)=NMI;
       risultato(j,numlivelli+3)=mean(fval(i,:));% media delle modularit? su tutti i livelli 
       risultato(j,numlivelli+4)=i;
       
       j=j+1;
    end % fine per tutti i ris non duplicati 
    
    
%

end

fprintf(fid,'result at iteration : %d \n',numtest);
fprintf(fid,'fval values for the %d layers,  Modularity full network, NMI average modularity, id of the solution\n',numlivelli);
for i1 = 1:size(risultato,1)
    for j1= 1:size(risultato,2)
       
            fprintf(fid,'%d ',risultato(i1,j1));
    end
    fprintf(fid,'\n');
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%computes the maximum NMI and modularity obtained among the results
[maxNMI,pos]=max(risultato(:,numlivelli+2));
[maxMOD,pos1]=max(risultato(:,numlivelli+1));
[meanModLevels, pos2]=min(risultato(:,numlivelli+3));


%NMIMODtot(1,1)= NMIMODtot(1,1) +maxNMI;
%NMIMODtot(2,1)= NMIMODtot(2,1) +maxMOD;
%NMIMODtot(1,2)= NMIMODtot(1,2) +risultato(pos,3);
%NMIMODtot(2,2)= NMIMODtot(2,2) +risultato(pos1,4);

NMIris(numtest,1)=maxNMI;
NMIris(numtest,2)=risultato(pos,numlivelli+1);%modularity corresponding to the max NMI

MODris(numtest,1)=maxMOD;
MODris(numtest,2)=risultato(pos1,numlivelli+2); %NMI corresponding to the max modulatity

MODmeanLivelli(numtest,1) =meanModLevels;%massima modularit? media su tutti i livelli
MODmeanLivelli(numtest,2)=risultato(pos2,numlivelli+2);%NMI corrispondente
%adesso chiamiamo la funzione per la scelta del modello
%restituisce la nuova matrice di adiacenza dei cluster SM 

[ SM] = consensusCSPA(H, numberOfVariables,M );

fprintf(fid1,'\nConsensus matrix\n');

for i1=1:size(SM,1)
    for j1=1:size(SM,1)
        fprintf(fid1,'%d ',SM(i1,j1));
    end
    fprintf(fid1,'\n');
end

[risCC rismod]= laststep(SM,maxGen,PopSize,CrossoverFraction,mutationRate,vettorizzato);

fprintf(fid1,'\n\n\n chosen solution of the Pareto Front d\n');

for i1=1:size(risCC,2) %
    listnodes=risCC{i1};
    for j1 = 1: size(listnodes,2)
        fprintf(fid1,'%d ',listnodes(j1));
    end
    fprintf(fid1,'\n');
end

%%%%%%%%%%%%%%%
%calcoliamo l'NMI
risNMI=0;
if numclassi>0
 classi=load(fileclassi);
 risCM=confusionMatrix(risCC,classi,numclassi); %generate confusion matrix 
 risNMI = computeNMI(risCM,numberOfVariables);
 fprintf(fid,'confusion matrix of the chosen solution: %d\n',i);
 for i1 = 1:size(risCM,1)
    for j1= 1:size(risCM,2)
       
            fprintf(fid,'%d ',risCM(i1,j1));
    end
    fprintf(fid,'\n');
 end
 fprintf(fid,'\n');
end
%print the current solution
fprintf(fid1,'communities of the chosen solution %d\n',i);

for i1=1:size(risCC,2) %
    listnodes=risCC{i1};
    for j1 = 1: size(listnodes,2)
        fprintf(fid1,'%d ',listnodes(j1));
    end
    fprintf(fid1,'\n');
end



NMIConsensus(numtest,1)=risNMI; %NMI della soluzione scelta con il consensus
    
NMIConsensus(numtest,2)=rismod;

end
clear risultato;
clear CC;
clear CM;


%NMItot

fprintf(fid,'\n max NMI and corresp. modularity: \n');
for i = 1:maxnum
    for j= 1:size(NMIris,2)
       
            fprintf(fid,'%d ',NMIris(i,j));
    end
    fprintf(fid,'\n');
end

fprintf(fid,'max modularity and corresp. NMI: \n');
for i = 1:maxnum
    for j= 1:size(MODris,2)
       
            fprintf(fid,'%d ',MODris(i,j));
    end
    fprintf(fid,'\n');
end


fprintf(fid,'\n NMI of the solution chosen with the consensus and corresp. modularity: \n');
for i = 1:maxnum
    for j= 1:size(NMIConsensus,2)
       
            fprintf(fid,'%d ',NMIConsensus(i,j));
    end
    fprintf(fid,'\n');
end

fprintf(fid,'\n max average modularity between layers and corresp. NMI: \n');
for i = 1:maxnum
    for j= 1:size(MODmeanLivelli,2)
       
            fprintf(fid,'%d ',MODmeanLivelli(i,j));
    end
    fprintf(fid,'\n');
end




mediaNMI=mean(NMIris(:,1)); %valore medio del max NMI
stdNMI = std(NMIris(:,1)); %deviazione standard del max NMI
mediaMOD=mean(NMIris(:,2)); %valore medio della max modularity corrispondente a max NMI
stdMOD=std(NMIris(:,2)); %deviazione standard della max modularity corrispondente a max NMI

mediaNMIConsensus=mean(NMIConsensus(:,1)); %valore medio dell' NMI del modello scelto con il consensus
stdNMIConsensus = std(NMIConsensus(:,1)); %deviazione standard dell' NMI del modello scelto con il consensus
mediaMODConsensus=mean(NMIConsensus(:,2)); %valore medio della max modularity corrispondente a max NMI consensus
stdMODConsensus=std(NMIConsensus(:,2)); %deviazione standard della max modularity corrispondente a max NMI consensus

mediamaxMOD=mean(MODris(:,1)); % valore medio della max MOD
stdmaxMOD=std(MODris(:,1)); % deviazione standard della max MOD
mediamaxmodNMI=mean(MODris(:,2)); %valore medio della max NMI corrispondente a max Modularity
stdmediamaxmodNMI=std(MODris(:,2)); %deviazione standard della max NMI corrispondente a max Modularity

mediaMODmeanLivelli=-mean(MODmeanLivelli(:,1)); % valore medio della max MOD medis tra i livelli
stdMODmeanLivelli=std(MODmeanLivelli(:,1)); % deviazione standard della max MOD media tra i livelli
mediaNMImeanLivelli=mean(MODmeanLivelli(:,2)); %valore medio della max NMI corrispondente a max Modularity
stdNMImeanLivelli=std(MODmeanLivelli(:,2)); %deviazione standard della max NMI corrispondente a max Modularity

fprintf(fid,'\n\n average max NMI value : %d \n',mediaNMI);
fprintf(fid,'standard deviation of max NMI : %d \n',stdNMI);

fprintf(fid,'\naverage modularity value corresponding to max NMI: %d\n',mediaMOD); 
fprintf(fid,' standard deviation of modularity value corresponding to max NMI: %d\n',stdMOD);


fprintf(fid,'\n\n\n average max modularity value multiplex: %d\n',mediamaxMOD);
fprintf(fid,'standard deviation of  max modularity multiplex: %d\n',stdmaxMOD);

fprintf(fid,'\naverage NMI value corresponding to max  Modularity multiplex: %d\n',mediamaxmodNMI);
fprintf(fid,'standard deviation of NMI value corresponding to max Modularity multiplex: %d\n',stdmediamaxmodNMI);

fprintf(fid,'\n\n\n average max NMI value of the consensus model: %d \n',mediaNMIConsensus);
fprintf(fid,'standard deviation of consensus NMI : %d \n',stdNMIConsensus);



fprintf(fid,'\n average modularity value corresponding to consensus NMI: %d\n',mediaMODConsensus); 
fprintf(fid,' standard deviation of modularity value corresponding to consensus NMI: %d\n',stdMODConsensus);

fprintf(fid,'\n\n\n average max modularity between layers: %d\n',mediaMODmeanLivelli);
fprintf(fid,'standard deviation of  max modularity between layers: %d\n',stdMODmeanLivelli);

fprintf(fid,'\naverage NMI value corresponding to max average Modularity between layers: %d\n',mediaNMImeanLivelli);
fprintf(fid,'standard deviation of NMI value corresponding to max average Modularity between layers: %d\n',stdNMImeanLivelli);




fprintf(fid,'\n\n time required %d ',timetot);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%
fclose(fid); 


end

function [mat] = edgesToadj(fileinput)

couple = load(fileinput);

for i=1:size(couple,1)
    mat(couple(i,1),couple(i,2)) = 1;
    mat(couple(i,2),couple(i,1)) = 1;
    
end
numRow=size(mat,1);
for i=1:numRow
    mat(i,i) = 0;
end
end




function CM= confusionMatrix(currCC,classi,numclass)



CM = zeros(numclass,size(currCC,2));

for k=1:size(currCC,2) %
    listnodes=currCC{k};
    for j = 1: size(listnodes,2)
        classe = classi(listnodes(j),2);
        CM(classe,k)=  CM(classe,k)+1;
    end
end
end

%This function compute the modularity of Girvan and Newman
function mod= computeMod(CC,M)

numEdges=sum(sum(M(:,:)));

mod=0;


for k=1:size(CC,2) %
    
    %ls is the number of edges joining nodes of the community k
    %ds is the sum of the degrees of the nodes belonging to the community k
    listnodes=CC{k};
    ls=sum(sum(M(listnodes,listnodes)));
    ds=sum(sum(M(listnodes,:)));
    mod=mod + (ls/numEdges - (ds/(numEdges))^2);
end

end

%questa funzione calcola la normalized mutual information a partire dalla matrice di 
%confusione CM tra il clustering  corrente
%contenuto in CC rispetto ad un risultato noto contenuto in filein.
%numclass ? il numero di clusters effettivi
%CM ? la matrice di confusione calcolata a partire da filein

function NMI= computeNMI(CM,n)

%n=128; %numero di nodi della rete. Per ora fissato a 128 ma dovrebbe essere parametr
NMI = 0.0;
numeratore = 0;

for i=1:size(CM,1) 
    
    Ni = sum(CM(i,:)); %somma gli elementi della riga i
  
    for j = 1: size(CM,2)
       
       if (CM(i,j) ~=0)
         Nj = sum(CM(:,j));  %somma gli elementi della colonna j
         numeratore = numeratore + CM(i,j) * log((CM(i,j)*n)/(Ni*Nj));
       end
    end
end

denom1=0;
for i=1:size(CM,1) 
    
    Ni = sum(CM(i,:)); %somma gli elementi della riga i
    denom1= denom1+ Ni * log(Ni/n);
end

denom2=0;
for j=1:size(CM,2) 
    
    Nj = sum(CM(:,j)); %somma gli elementi della colonna j
    denom2= denom2+ Nj * log(Nj/n);
end
    NMI = -2*numeratore/(denom1 + denom2);
end

function pos=bestNeighbor(node,Neighbor) %trova per ogni nodo il vicino con cui condivide il massimo numero di vicini
maxshared=-1;
pos=0;
%Neighbor{node}
for j=1:size(Neighbor{node},2)
    if (j ~= node)
       vicino=Neighbor{node}(j);
       shared=size(intersect(Neighbor{node},Neighbor{vicino}),2);
       if(shared > maxshared)
        maxshared=shared;
        pos=j;
       end
    end
end
end

function [mat]=MLedgesToadj(fileinput,numlivelli) 

triple = load(fileinput);

for i=1:size(triple,1)
    
    mat(triple(i,1),triple(i,2),triple(i,3)) = 1;
    mat(triple(i,2),triple(i,2),triple(i,3)) = 1;
    
end
numRow=size(mat,1);
for j=1:numlivelli
for i=1:numRow
    mat(i,i,j) = 0;
end
end
end
